package com.mobithink.tracesdk.sample;

import java.util.HashMap;
import java.util.Map;

import com.mobithink.tracesdk.TraceAgent;

import android.os.Bundle;
import android.support.v4.app.FragmentActivity;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

public class MainActivity extends FragmentActivity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		TraceAgent.active(MainActivity.this, "5486");
		Button btnEvent = (Button) findViewById(R.id.send);
		Button btnUp = (Button) findViewById(R.id.upgrade);
		Button btnPurchase = (Button) findViewById(R.id.purchase);
		Button btnReg = (Button) findViewById(R.id.reg);
		btnEvent.setOnClickListener(listener);
		btnUp.setOnClickListener(listener);
		btnPurchase.setOnClickListener(listener);
		btnReg.setOnClickListener(listener);
	}

	@Override
	protected void onPause() {
		TraceAgent.onPause(this);
		super.onPause();
	}

	@Override
	protected void onResume() {
		TraceAgent.onResume(this);
		super.onResume();
	}

	OnClickListener listener = new OnClickListener() {

		@Override
		public void onClick(View v) {
			Boolean a;
			switch (v.getId()) {
			case R.id.send:
				TraceAgent.onEvent(getApplicationContext(), "test_event");
				break;
			case R.id.purchase:
				TraceAgent.onPurchase(getApplicationContext(), "USD", 10.5f);
				break;
			case R.id.upgrade:
				TraceAgent.onUpgrade(getApplicationContext(), "11");
				break;
			case R.id.reg:
				TraceAgent.onRegister(getApplicationContext());
				break;
			}
		}
	};
}
